︠8d6ace16-7753-4be2-b9f7-f3849d46be14s︠

︡c16972e0-51cc-437f-958d-a4cb4956b76a︡{"done":true}
︠2e2514ee-afa5-43f6-bade-d35960bebf7casi︠
%auto
typeset_mode(True, display=False)
︡fadbd46e-af68-45a1-aacd-6a113002d4f7︡{"done":true}︡
︠48c91ef2-d142-40cd-b09c-319b54708cbf︠
%html
<h2 style="text-align: center;"><span style="font-size: medium;"><strong>Les multiplicateurs de Lagrange :&nbsp; motivation<br /></strong></span></h2>
<p><span style="font-size: medium;"><strong><br /></strong></span></p>
<p><span style="font-size: medium;"><strong>Exemple:</strong> On consid&eacute;re la fonction $f(x,y)=(x-1)^2+(y-2)^2$. Parmi les points $(x,y)$ sur le cercle $x^2+y^2=45$, on cherche celui o&ugrave; $f$ atteint son minimum/maximum.</span></p>

︡7ecfc076-ced6-4fa7-8a52-9918a47de01a︡{"done":true,"html":"<h2 style=\"text-align: center;\"><span style=\"font-size: medium;\"><strong>Les multiplicateurs de Lagrange :&nbsp; motivation<br /></strong></span></h2>\n<p><span style=\"font-size: medium;\"><strong><br /></strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Exemple:</strong> On consid&eacute;re la fonction $f(x,y)=(x-1)^2+(y-2)^2$. Parmi les points $(x,y)$ sur le cercle $x^2+y^2=45$, on cherche celui o&ugrave; $f$ atteint son minimum/maximum.</span></p>"}
︠84a4eecb-ad39-413a-aa78-77508582d0d1si︠
import matplotlib.cm;
%typeset_mode True
var('u,v')
f(x,y)=(x-1)^2+(y-2)^2
r=sqrt(45)
︡0765c144-e004-4255-bac9-8e6dfd7f7e72︡{"html":"<div align='center'>($\\displaystyle u$, $\\displaystyle v$)</div>"}︡{"done":true}
︠2d93c718-c7f5-4685-9e72-83664a753a8es︠

︡981e6aae-0391-43ce-97d5-18d238b6ca97︡{"done":true}
︠22e4ab26-faa6-4a55-a185-74ce4d17e603si︠
cmsel = [colormaps.Blues(_) for _ in sxrange(0.45,1,0.02)]
S=plot3d(f(u,v),(u,-r-1,r+1),(v,-r-1,r+1), adaptive = True, color = cmsel);
C=parametric_plot3d([r*cos(v),r*sin(v),0],(v,0,2*pi), color='red', thickness=2)
CS=parametric_plot3d([r*cos(v),r*sin(v),f(r*cos(v), r*sin(v))],(v,0,2*pi), color='red', thickness=3)
show(S+C+CS, frame_aspect_ratio=[10,10,1]);
︡80a34735-2a67-4b3a-ac90-7598d1a3a7d1︡{"file":{"filename":"d42d14de-5cdd-4f7c-8f94-e3259398652c.sage3d","uuid":"d42d14de-5cdd-4f7c-8f94-e3259398652c"}}︡{"done":true}
︠efcf88aa-6428-483d-9686-c329f6d872d3s︠
df=f.gradient()
︡5fe887ae-9333-4e97-a74c-750bde096c83︡{"done":true}
︠4cdb4615-9ffe-4413-9f53-00444bb65af8i︠
%html
<p><span style="font-size: medium;">Voyons le probl&egrave;me en termes de courbes de niveau et du champ gradient de $f$. Rappelons que $\nabla f(x_0,y_0)$ donne la direction dans laquelle il faut se d&eacute;placer &agrave; partir de $(x_0,y_0)$ pour avoir la plus forte augmentation dans la valeur de $f$ .</span></p>
<p><span style="font-size: medium;"><br /></span></p>
<p><span style="font-size: medium;">Ci-bas, on trouve les courbes de niveau de $f$, le champ $\nabla f$ et la courbe $x^2+y^2=45$ (en rouge)<br /></span></p>

︡97cbb47d-40ba-4137-a97f-30ac8012d8eb︡{"html": "<p><span style=\"font-size: medium;\">Voyons le probl&egrave;me en termes de courbes de niveau et du champ gradient de $f$. Rappelons que $\\nabla f(x_0,y_0)$ donne la direction dans laquelle il faut se d&eacute;placer &agrave; partir de $(x_0,y_0)$ pour avoir la plus forte augmentation dans la valeur de $f$ .</span></p>\n<p><span style=\"font-size: medium;\"><br /></span></p>\n<p><span style=\"font-size: medium;\">Ci-bas, on trouve les courbes de niveau de $f$, le champ $\\nabla f$ et la courbe $x^2+y^2=45$ (en rouge)<br /></span></p>"}︡
︠6c22afc4-e09b-452f-bf23-42302b35ff13s︠
r2 = sqrt(48)
Champf=plot_vector_field(df, (x,-r,r), (y,-r,r), color='darkblue',aspect_ratio=1)
Contourf=contour_plot(f(u,v),(u,-r,r),(v,-r,r),cmap='Blues',labels=True, linestyles='solid',aspect_ratio=1);
Cercle = parametric_plot([r*cos(u),r*sin(u)],(u,0,2*pi), color='red', thickness=2,aspect_ratio=1)
Cercle2 = parametric_plot([r2*cos(u),r2*sin(u)],(u,0,2*pi), color='red', linestyle = "dashed",thickness=1,aspect_ratio=1)
show(Contourf+Cercle+Champf);
︡e1280bb6-15e0-4cd6-928b-02b748f8681b︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/373/tmp_WqVucX.svg","show":true,"text":null,"uuid":"03e2d54c-cadb-442a-be8e-253aa828925d"},"once":false}︡{"done":true}
︠0dbf0afc-5e46-40d3-b5aa-56e23756aac1i︠
%html
<p><span style="font-size: medium;">La courbe de contrainte est donn&eacute; par $g(x,y)=45$, o&ugrave; $g(x,y)=x^2+y^2$, c'est donc une courbe de niveau pour la fonction de contrainte $g$. Cette fonction a aussi un champ gradient, $\nabla g$. Dessinons les vecteurs de ce champ, mais seulement ceux qui correspondent aux points sur la courbe.</span></p>

︡57f7fd8c-4132-44e6-b916-7bf806b11b86︡{"html": "<p><span style=\"font-size: medium;\">La courbe de contrainte est donn&eacute; par $g(x,y)=45$, o&ugrave; $g(x,y)=x^2+y^2$, c'est donc une courbe de niveau pour la fonction de contrainte $g$. Cette fonction a aussi un champ gradient, $\\nabla g$. Dessinons les vecteurs de ce champ, mais seulement ceux qui correspondent aux points sur la courbe.</span></p>"}︡
︠dc20b85f-924a-4875-8c96-72537c3cfe40s︠

︡0fac7225-3a7e-4d40-aaeb-554db346bec3︡{"done":true}
︠63b46f1f-0c75-4f68-8951-d5f2845a45fas︠
Pts=[(r*cos(2*t*pi/20),r*sin(2*t*pi/20)) for t in range(20)];
Pts1=[(1.1*r*cos(2*t*pi/20),1.1*r*sin(2*t*pi/20)) for t in range(20)];
Vecs=[arrow(Pts[j],Pts1[j],color='red', width=1) for j in range(20)];
Champg=sum(Vecs)
︡13038497-c318-47a2-bf1b-e000e718f528︡{"done":true}
︠8ab6aeb0-d85f-43c2-9a7b-5d9262bf7be3s︠
show(Contourf+Cercle+Champf+Champg,aspect_ratio=1, figsize = 8);
︡b3251231-caa3-4115-b58b-1ef425dcd2a5︡{"file":{"filename":"/projects/376921f2-eda3-44fc-b33d-1550746c3549/.sage/temp/compute6-us/17462/tmp_2AeNe_.svg","show":true,"text":null,"uuid":"06d12db1-2097-48a2-987e-2f60265660eb"},"once":false}︡{"done":true}︡
︠e37cf29e-aef1-4bb5-8314-52e1b5159e9di︠
%html
<p><strong><span style="font-size: medium;">Conjecture : </span></strong><span style="font-size: medium;">Les points de maximum / minimum de $f$ sur la courbe $g=45$ sont pr&eacute;cis&eacute;ment ceux pour lequels les vecteurs gradient $\nabla f$ et $\nabla g$ sont colin&eacute;aires. En d'autres termes, il doit exister $\lambda\in \mathbb{R}$ tel&nbsp; que&nbsp; $$\nabla f = \lambda \nabla g$$</span></p>
<p><span style="font-size: medium;"><br /></span></p>
<p><span style="font-size: medium;">Demandons &agrave; SAGE de r&eacute;soudre les &eacute;quations qu'on a besoin de r&eacute;soudre. La fonction $f$ a d&eacute;j&agrave; &eacute;t&eacute; d&eacute;finie, mais pas $g$, et nous avons &eacute;galement besoin d'une variable suppl&eacute;mentaire $L$, pour $\lambda$.<br /></span></p>

︡9fdb60ad-1842-43d0-9a28-96909e82e9dc︡{"html": "<p><strong><span style=\"font-size: medium;\">Conjecture : </span></strong><span style=\"font-size: medium;\">Les points de maximum / minimum de $f$ sur la courbe $g=45$ sont pr&eacute;cis&eacute;ment ceux pour lequels les vecteurs gradient $\\nabla f$ et $\\nabla g$ sont colin&eacute;aires. En d'autres termes, il doit exister $\\lambda\\in \\mathbb{R}$ tel&nbsp; que&nbsp; $$\\nabla f = \\lambda \\nabla g$$</span></p>\n<p><span style=\"font-size: medium;\"><br /></span></p>\n<p><span style=\"font-size: medium;\">Demandons &agrave; SAGE de r&eacute;soudre les &eacute;quations qu'on a besoin de r&eacute;soudre. La fonction $f$ a d&eacute;j&agrave; &eacute;t&eacute; d&eacute;finie, mais pas $g$, et nous avons &eacute;galement besoin d'une variable suppl&eacute;mentaire $L$, pour $\\lambda$.<br /></span></p>"}︡
︠b16e7ba7-1467-4624-9447-718bd8103be9s︠
g(x,y)=x^2+y^2
dg=g.gradient()
var('L')
df(x,y)
dg(x,y)
︡42a719b6-2b89-408e-9420-80605be22f79︡{"stdout":"L\n"}︡{"stdout":"(2*x - 2, 2*y - 4)"}︡{"stdout":"\n"}︡{"stdout":"(2*x, 2*y)\n"}︡{"done":true}
︠d35a5d73-1088-45ad-a56b-6ee06017c780s︠
solve([df[0](x,y)==L*dg[0](x,y), df[1](x,y)==L*dg[1](x,y), g(x,y)==45],[x,y,L])
︡53dd9eb6-a86c-4cc8-a028-a1b44bd5147f︡{"stdout":"[[x == -3, y == -6, L == (4/3)], [x == 3, y == 6, L == (2/3)]]"}︡{"stdout":"\n"}︡{"done":true}
︠9a7fd21a-ca19-4ef8-85bf-3f362b0f43e6s︠

︡ccc6188e-1b0c-4dd9-95d7-dc3258a9646b︡{"done":true}
︠3ab7cfc0-a04b-4088-9d70-8e45dfa66990i︠
%html
<p><span style="font-size: medium;">Ici, $df$ est le gradient de $f$, c'est donc une paire de fonctions de deux variables (voir plus bas). Ainsi df[0] est la premi&egrave;re de ces deux fonctions (il y a des gens qui commencent &agrave; compter &agrave; 0), c'est &agrave; dire $\frac{\partial f}{\partial x}$ puis $df[0](x,y)$ est la premi&egrave;re de ces fonctions &eacute;valu&eacute;e en (x,y).</span></p>

︡20d90448-2121-482f-9f56-67cc2b97bd4f︡{"html": "<p><span style=\"font-size: medium;\">Ici, $df$ est le gradient de $f$, c'est donc une paire de fonctions de deux variables (voir plus bas). Ainsi df[0] est la premi&egrave;re de ces deux fonctions (il y a des gens qui commencent &agrave; compter &agrave; 0), c'est &agrave; dire $\\frac{\\partial f}{\\partial x}$ puis $df[0](x,y)$ est la premi&egrave;re de ces fonctions &eacute;valu&eacute;e en (x,y).</span></p>"}︡
︠89c795c7-f0dd-4ade-b418-f6e7c6e0fdbfs︠
dg
︡b2929f8e-b513-4fff-95d1-1eeea6246e12︡
︠d022f0e8-68b7-483b-a8c1-7fd947eaa9f2s︠
dg[0]
︡ef984dd4-156a-4c26-98c8-791505efc346︡{"stdout":"(x, y) |--> 2*x\n"}︡{"done":true}
︠a52c2878-844e-42c2-ae8a-6fe1b6c9e6dcs︠
dg[0](pi,-pi)
︡53bd115b-81d7-4d13-a83f-94c81fe2a633︡{"stdout":"2*pi\n"}︡{"done":true}
︠2dd90a98-b78c-4edb-8a86-1572e1773f97︠









